<?php
require_once("admin-pages.php");
require_once("widget.php");
require_once("functions/shortcodes.php");
require_once("class_addons.php");
require_once('functions/includes.php');
require_once('functions/navi-rcl.php');

function get_init_filters_actions_rcl(){
	global $rcl_options;
	if (!is_admin()):
		add_action('wp_enqueue_scripts', 'output_style_scripts_recall');
		add_action('wp_enqueue_scripts', 'foot_scripts_uuf');
		if(!$rcl_options['login_form_recall']) add_filter('wp_footer', 'login_form_rcl',99);
		
		add_filter('get_comment_author_url', 'add_link_author_in_page');					
		add_action('wp_head','hidden_admin_panel');
			  			
		if($rcl_options['login_form_recall']==1) add_filter('wp_enqueue_scripts', 'script_page_form_recall');
		else if(!$rcl_options['login_form_recall']) add_filter('wp_enqueue_scripts', 'script_float_form_recall');
	endif;

	if (is_admin()):		
		
		add_action('save_post', 'recall_postmeta_update', 0);
	endif;

		add_action('wp_head','rcl_update_timeaction_user');
		add_filter('get_avatar','custom_avatar_recall', 1, 5);	
		add_action('before_delete_post', 'delete_attachments_with_post_rcl');
		
	if(is_admin()):
		add_action('admin_head','output_script_style_admin_recall');
		add_action('admin_menu', 'wp_recall_options_panel',19);
		
	endif;	
}
add_action('init','get_init_filters_actions_rcl');

function script_page_form_recall(){
	wp_enqueue_script( 'page_form_recall', RCL_URL.'js/page_form.js' );
}
function script_float_form_recall(){
	wp_enqueue_script( 'float_form_recall', RCL_URL.'js/float_form.js' );
}
	
function output_style_scripts_recall(){

	global $rcl_options;
	if(!isset($rcl_options['font_icons']))  $rcl_options['font_icons']=1;
	wp_enqueue_style( 'fileapi_static', RCL_URL.'js/fileapi/statics/main.css' );
	wp_enqueue_style( 'fileapi_jcrop', RCL_URL.'js/fileapi/jcrop/jquery.Jcrop.min.css' );
	wp_enqueue_style( 'bx-slider-css', RCL_URL.'js/jquery.bxslider/jquery.bxslider.css' );
	if($rcl_options['font_icons']==1) wp_enqueue_style( 'font-awesome', RCL_URL.'fonts/font-awesome.min.css' );
	if($rcl_options['minify_css']==1){
		//$file_ex = file_exists(TEMP_PATH.'css/minify.css');
		if($rcl_options['custom_scc_file_recall']!=''){
			wp_enqueue_style( 'style_custom_rcl', $rcl_options['custom_scc_file_recall'] );
		}else{		
			wp_enqueue_style( 'style_recall', TEMP_URL.'css/minify.css' );
		}
	}else{	
            $css_ar = array('lk','recbar','regform','slider','users','style');
            foreach($css_ar as $name){wp_enqueue_style( 'style_'.$name, RCL_URL.'css/'.$name.'.css' );}		
	}
	if($rcl_options['color_theme']) wp_enqueue_style( 'theme_rcl', RCL_URL.'css/themes/'.$rcl_options['color_theme'].'.css' );
	
	wp_enqueue_script( 'jquery' );
	wp_enqueue_script( 'bx-slider', RCL_URL.'js/jquery.bxslider/jquery.bxslider.js' );
	wp_enqueue_script( 'rangyinputs', RCL_URL.'js/rangyinputs.js' );	
	wp_enqueue_script( 'recall_recall', RCL_URL.'js/recall.js', array(), VER_RCL );
	if(!file_exists(TEMP_PATH.'scripts/header-scripts.js')){
		$rcl_addons = new rcl_addons();
		$rcl_addons->get_update_scripts_file_rcl();
	}
	wp_enqueue_script( 'temp-scripts-recall', TEMP_URL.'scripts/header-scripts.js', array(), VER_RCL );	
}

function output_script_style_admin_recall(){
	wp_enqueue_style( 'admin_recall', RCL_URL.'css/admin.css' );
	wp_enqueue_script( 'jquery' );
	wp_enqueue_script( 'primary_script_admin_recall', RCL_URL.'js/admin.js', array(), VER_RCL );
	if(isset($_GET['page'])){
		if($_GET['page']=='manage-userfield'||$_GET['page']=='manage-custom-fields'||$_GET['page']=='manage-public-form') wp_enqueue_script( 'script_sortable_recall', RCL_URL.'js/sortable.js' );
	}
}

function foot_scripts_uuf() {
	if(file_exists(TEMP_PATH.'scripts/footer-scripts.js')){
		//get_update_scripts_footer_rcl();
		wp_enqueue_script( 'jquery' );	
		wp_enqueue_script( 'FileAPI-min', RCL_URL.'js/fileapi/FileAPI/FileAPI.min.js', array(), VER_RCL, true );
		wp_enqueue_script( 'mousewheel-js', RCL_URL.'js/fileapi/FileAPI/FileAPI.exif.js', array(), VER_RCL, true );
		wp_enqueue_script( 'fileapi-pack-js', RCL_URL.'js/fileapi/jquery.fileapi.js', array(), VER_RCL, true );
		wp_enqueue_script( 'Jcrop-buttons-js', RCL_URL.'js/fileapi/jcrop/jquery.Jcrop.min.js', array(), VER_RCL, true );
		wp_enqueue_script( 'modal-thumbs-js', RCL_URL.'js/fileapi/statics/jquery.modal.js', array(), VER_RCL, true );
		wp_enqueue_script( 'footer-js-recall', TEMP_URL.'scripts/footer-scripts.js', array(), VER_RCL, true );
	}
}

function minify_style_rcl(){
	global $rcl_options;	
	if($rcl_options['minify_css']!=1) return false;
	
	$css_dir = RCL_PATH.'css/';
	$css_ar = array(
		$css_dir.'lk.css',
		$css_dir.'recbar.css',
		$css_dir.'regform.css',
		$css_dir.'slider.css',
		$css_dir.'users.css',
		$css_dir.'style.css'
	);
	
	$csses = apply_filters('csspath_array_rcl',$css_ar);

	$path = TEMP_PATH.'css/';
	if(!is_dir($path)){
		mkdir($path);
		chmod($path, 0755);
	}
	$filename = 'minify.css';
	$file_src = $path.$filename;		
	$f = fopen($file_src, 'w');
		
	$fullcss = '';
	foreach($csses as $k=>$css_path){
		if(!file_exists($css_path)) continue;
                $string_value = '';
		preg_match_all("/(?<=\/wp\-content\/)[A-z0-9\-\/\.\_\s\ё]*(?=)/i", $css_path, $string_value);
		if($k!==0) $fullcss .= "\n\n";
		$fullcss .= '/*'.$string_value[0][0].'*/'."\r\n";	
		$fullcss .= file_get_contents($css_path);	
	}
	
	//$fullcss = str_replace(array("\r\n", "\r", "\n", "\t"), " ", $fullcss);
	//$fullcss =  preg_replace('/ {2,}/',' ',$fullcss);
	fwrite($f, $fullcss);
	fclose($f);
}

function update_dinamic_files_rcl(){
    //include('class_addons.php');
    $rcl_addons = new rcl_addons();
    $rcl_addons->get_update_scripts_file_rcl();
    $rcl_addons->get_update_scripts_footer_rcl();
    minify_style_rcl(); 
}

function add_ajax_rcl($function,$nopriv=0){
    add_action('wp_ajax_'.$function, $function);
    if($nopriv) add_action('wp_ajax_nopriv_'.$function, $function); 
}

add_action('wp_ajax_rcl_ajax_tab', 'rcl_ajax_tab');
add_action('wp_ajax_nopriv_rcl_ajax_tab', 'rcl_ajax_tab');
function rcl_ajax_tab(){
    global $array_tabs;
    $id_tab = $_POST['id'];
    $function = $array_tabs[$id_tab];

    if(!$array_tabs[$id_tab]){  
        $log['content']='Ошибка! Возможно, данное дополнение не поддерживает ajax-загрузку';
    }else{  
        if ( false !== strpos($function, '->') ){
            $func_array = explode('->',$function);
            $class = $func_array[0];
            $function = $func_array[1];
            $object = new $class();
            $log['content']=$object->$function('',$_POST['lk']);
        }else{
            $log['content']=$function('',$_POST['lk']);
        }        
    }
    
    $log['result']=100;
    echo json_encode($log);	
    exit;
}

add_action('init','init_ajax_tabs');
function init_ajax_tabs(){
        global $array_tabs;
        $id_tabs = '';
	$array_tabs = apply_filters( 'ajax_tabs_rcl', $id_tabs );
	return $array_tabs;
}

function get_name_tab_rcl($name,$key){
	global $rcl_options;
	$content = '<label>Название вкладки в ЛК</label>';
	if(!$rcl_options['tab_'.$key]) $rcl_options['tab_'.$key] = $name;
	$content .= '<input type="text" name="tab_'.$key.'" value="'.$rcl_options['tab_'.$key].'" size="10">
	<small>Впишите свою надпись на кнопке переключения вкладки в личном кабинете</small>';
	return $content;
}

function get_button_rcl($button,$author_lk,$args){
	global $rcl_options;
	$link = get_redirect_url_rcl(get_author_posts_url($author_lk),$args['id_tab']);
	if($rcl_options['tab_'.$args['key']]) $name = $rcl_options['tab_'.$args['key']];
	else $name = $args['name'];
	if(!$button) $status = 'active';
	
	$button .= '<a href="'.$link.'" id="'.$args['id_tab'].'" class="'.$status.' '.get_class_button_tab($button).'"><i class="fa '.$args['class'].'"></i>'.$name.'</a>';
	return $button;
}

function chek_view_tab($block_wprecall,$idtab){
	global $rcl_options;
	if($rcl_options['tab_newpage']){
		if((!isset($_GET['view'])&&$block_wprecall)||(isset($_GET['view'])&&$_GET['view']!=$idtab)) return false;
	}
	return true;
}

function get_class_button_tab($button=''){
	global $rcl_options;
	if(!$rcl_options['tab_newpage']) $class = 'block_button';
	if($rcl_options['tab_newpage']==2) $class = 'ajax_button';		
	if(!$button) $class .= ' active';
	return $class;
}

function add_user_data_rcl(){
    global $user_ID;
    $data = '<script>var user_ID = '.$user_ID.';</script>';
    echo $data;
}
add_action('wp_head','add_user_data_rcl');	

add_filter('wp_footer', 'add_footer_url_recall');
function add_footer_url_recall(){
	global $rcl_options;
	if($rcl_options['footer_url_recall']!=1) return false;
	if(is_front_page()&&!is_user_logged_in()) echo '<p class="plugin-info">'.__('Сайт работает с использованием функционала плагина','rcl').'  <a target="_blank" href="http://wppost.ru/">Wp-Recall</a></p>';
}

function rcl_notify(){
    if (isset($_GET['updated'])) echo '<div class="box-green"><strong>'.__('Ваш профиль был обновлен','rcl').'</strong><br /></div>';
}

function delete_user_action_rcl($user){
	global  $wpdb;
	$wpdb->query("DELETE FROM ".RCL_PREF."user_action WHERE user = '$user'");
}
add_action('delete_user','delete_user_action_rcl');

function confirm_user_registration(){
global $wpdb;

	$reglogin = $_GET['rglogin'];
	$regpass = $_GET['rgpass'];
	$regcode = md5($reglogin);
	if($regcode==$_GET['rgcode']){
		if ( $user = get_user_by('login', $reglogin) ){
			wp_update_user( array ('ID' => $user->ID, 'role' => get_option('default_role')) ) ;
			$time_action = date("Y-m-d H:i:s");
			$wpdb->insert( RCL_PREF.'user_action', array( 'user' => $user->ID, 'time_action' => $time_action ) );
			
			$creds = array();
			$creds['user_login'] = $reglogin;
			$creds['user_password'] = $regpass;
			$creds['remember'] = true;			
			$sign = wp_signon( $creds, false );
			
			if ( is_wp_error($sign) ){
				wp_redirect( get_bloginfo('wpurl').'?getconfirm=needed' ); exit;
			}else{				
				rcl_update_timeaction_user();					
				wp_redirect(get_authorize_url_rcl($user->ID) ); exit;
			}
		}			
	}else{
		wp_redirect( get_bloginfo('wpurl').'?getconfirm=needed' ); exit;
	}	
}

function confirm_user_resistration_activate(){
global $rcl_options;
  if (isset($_GET['rgcode'])&&isset($_GET['rglogin'])){
	if($rcl_options['confirm_register_recall']==1) add_action( 'wp', 'confirm_user_registration' ); 
  }
}
add_action('init', 'confirm_user_resistration_activate');

add_action('wp_authenticate','chek_user_authenticate');
function chek_user_authenticate($email){
	global $rcl_options;
	if($rcl_options['confirm_register_recall']==1){ 
		if ( $user = get_user_by('login', $email) ){
			$user_data = get_userdata( $user->ID );
			$roles = $user_data->roles;
			$role = array_shift($roles);
			if($role=='need-confirm'){
				wp_redirect( get_bloginfo('wpurl').'?getconfirm=needed' ); exit;
			}
		}
	}
}

function get_login_user_rcl(){

	$pass = $_POST['pass-user'];
	$login = $_POST['login-user'];
	$member = $_POST['member-user'];
	
	if($pass&&$login){
	
		if ( $user = get_user_by('login', $login) ){
			$user_data = get_userdata( $user->ID );
			$roles = $user_data->roles;
			$role = array_shift($roles);
			if($role=='need-confirm'){
				wp_redirect(get_redirect_url_rcl($_POST['referer_rcl']).'action-rcl=login&err=confirm');exit;
			}
		}
				$creds = array();
				$creds['user_login'] = $login;
				$creds['user_password'] = $pass;
				$creds['remember'] = $member;
				$user = wp_signon( $creds, false );
				if ( is_wp_error($user) ){
					wp_redirect(get_redirect_url_rcl($_POST['referer_rcl']).'action-rcl=login&err=failed');exit;
				}else{
					rcl_update_timeaction_user();					
					wp_redirect(get_authorize_url_rcl($user->ID));exit;
				}						
	}else{		
		wp_redirect(get_redirect_url_rcl($_POST['referer_rcl']).'action-rcl=login&err=empty');exit;
	} 
}

add_action('init', 'get_login_user_rcl_activate');
function get_login_user_rcl_activate ( ) {
  if ( isset( $_POST['submit-login'] ) ) {
	if( !wp_verify_nonce( $_POST['_wpnonce'], 'login-key-rcl' ) ) return false;	
    add_action( 'wp', 'get_login_user_rcl' );
  }
}

function get_authorize_url_rcl($user_id){
	global $rcl_options;
	if($rcl_options['authorize_page']){
		if($rcl_options['authorize_page']==1) $redirect = $_POST['referer_rcl'];
		if($rcl_options['authorize_page']==2) $redirect = $rcl_options['custom_authorize_page'];
		if(!$redirect) $redirect = get_author_posts_url($user_id);
	}else{
		$redirect = get_author_posts_url($user_id);
	}
	return $redirect;
}

function get_register_user_rcl(){
	global $wpdb,$rcl_options;
	$pass = $_POST['pass-user'];	
	$email = $_POST['email-user'];	
	$login = $_POST['login-user'];
	
	$ref = $_POST['referer-rcl'];
	
	$get_fields = get_option( 'custom_profile_field' );
	$get_fields = unserialize( $get_fields);
	$requared = true;
	if($get_fields){	
		foreach((array)$get_fields as $custom_field){				
			$slug = str_replace('-','_',$custom_field['slug']);
			if($custom_field['requared']==1&&$custom_field['register']==1){
				if($custom_field['type']=='checkbox'){
					$chek = explode('#',$custom_field['field_select']);
					$count_field = count($chek);
					for($a=0;$a<$count_field;$a++){
						$slug_chek = $slug.'_'.$a;
						if($_POST[$slug_chek]=='undefined'){
							$requared = false;
						}else{
							$requared = true;
							break;
						}
					}
				}else{
					if(!$_POST[$slug]) $requared = false;	
				}
			}
		}
	}

	if(!$pass||!$email||!$login||!$requared){
		wp_redirect(get_redirect_url_rcl($ref).'action-rcl=register&err=empty');exit;
	}
	
	$res_email = email_exists( $email );
	$res_login = username_exists($login);
	$correctemail = is_email($email);
	$valid = validate_username($login);
	if($res_login||$res_email||!$correctemail||!$valid){
		if(!$valid){
			wp_redirect(get_redirect_url_rcl($ref).'action-rcl=register&err=login');exit;
		}
		if($res_login){
			wp_redirect(get_redirect_url_rcl($ref).'action-rcl=register&err=login-us');exit;
		}
		if($res_email){			
			wp_redirect(get_redirect_url_rcl($ref).'action-rcl=register&err=email-us');exit;
		}		
		if(!$correctemail){			
			wp_redirect(get_redirect_url_rcl($ref).'action-rcl=register&err=email');exit;
		}						
	}else{					
			$fio='';
			$userdata = array(
				'user_pass' => $pass
				,'user_login' => $login
				,'user_nicename' => ''
				,'user_email' => $email
				,'display_name' => $fio
				,'nickname' => $login
				,'first_name' => $fio
				,'rich_editing' => 'true'
			);

			$user_id = wp_insert_user( $userdata );
			update_user_meta($user_id, 'show_admin_bar_front', 'false');
			
		if($user_id){	
		
			if($get_fields){			
				foreach((array)$get_fields as $custom_field){				
					$slug = str_replace('-','_',$custom_field['slug']);
					if($custom_field['type']=='checkbox'){
						$chek = explode('#',$custom_field['field_select']);
						$count_field = count($chek);
						for($a=0;$a<$count_field;$a++){
							$slug_chek = $slug.'_'.$a;
							if($_POST[$slug_chek]!='undefined') update_usermeta($user_id, $slug_chek, $_POST[$slug_chek]);
						}
					}else{
						if($_POST[$slug]) update_usermeta($user_id, $slug, $_POST[$slug]);	
					}
				}
			}
			
			$regcode = md5($login);	
			
			add_filter('wp_mail_content_type',create_function('', 'return "text/html";'));
			$headers = 'From: '.get_bloginfo('name').' <noreply@'.$_SERVER['HTTP_HOST'].'>' . "\r\n";
			$subject = 'Подтвердите регистрацию!';														
			$textmail = '
			<p>Вы или кто то другой зарегистрировались на сайте "'.get_bloginfo('name').'" со следующими данными:</p>
			<p>Логин: '.$login.'</p>
			<p>Пароль: '.$pass.'</p>';
			
			if($rcl_options['confirm_register_recall']==1){				
				wp_update_user( array ('ID' => $user_id, 'role' => 'need-confirm') ) ;
				$res['recall']='<p style="text-align:center;color:green;">Регистрация завершена!<br />Для подтверждения регистрации перейдите по ссылке в письме, высланном на указанную вами почту.</p>';
				$textmail .= '<p>Если это были вы, то подтвердите свою регистрацию перейдя по ссылке ниже:</p>
				<p>'.get_bloginfo('wpurl').'/?rglogin='.$login.'&rgpass='.$pass.'&rgcode='.$regcode.'</p>
				<p>Не получается активировать аккаунт?</p>
				<p>Скопируйте текст ссылки ниже, вставьте его в адресную строку вашего браузера и нажмите Enter</p>';
			}else{
				$res['recall']='<p style="text-align:center;color:green;">Регистрация завершена!<br />Авторизуйтесь на сайте, используя логин и пароль указанные при регистрации</p>';
				$wpdb->insert( RCL_PREF.'user_action', array( 'user' => $user_id, 'time_action' => '' ));
			}
			
			$textmail .= '<p>Если это были не вы, то просто проигнорируйте это письмо</p>
			<p>------------------------------------------------------------</p>
			<p>Это письмо было создано автоматически, не надо отвечать на него</p>';				
			wp_mail($email, $subject, $textmail, $headers);					
										
			wp_redirect(get_redirect_url_rcl($ref).'action-rcl=login&success=true');exit;									
		}						
	}
}

add_action('init', 'get_register_user_rcl_activate');
function get_register_user_rcl_activate ( ) {
  if ( isset( $_POST['submit-register'] ) ) {
	if( !wp_verify_nonce( $_POST['_wpnonce'], 'register-key-rcl' ) ) return false;	
    add_action( 'wp', 'get_register_user_rcl' );
  }
}

add_filter('rcl_posthead_user','get_author_name_rcl',10,2);
function get_author_name_rcl($content,$user_id){
	$content .= "<h3>Автор: <a href='".get_author_posts_url($user_id)."'>".get_the_author_meta( 'display_name', $user_id )."</a></h3>".get_miniaction_user_rcl(false,$user_id);
	return $content;
}

function get_author_block_content_rcl(){
	global $post;
	$author = $post->post_author;
	
	$karma = apply_filters('get_all_rayt_user_rcl',$karma,$author);
	
	$out = "<div id='block_author-rcl'>
			<div class='avatar-author'>".get_avatar($author,60);
			if(function_exists('get_rayting_block_rcl')) $out .= get_rayting_block_rcl($karma);
			$out .= "</div>
			<div class='content-author-block'>";
				$head = apply_filters('rcl_posthead_user',$head,$author);
				$out .= $head;
				$desc = apply_filters('rcl_postdesc_user',$desc,$author);
				$out .= $desc;
				$footer = apply_filters('rcl_postfooter_user',$footer,$author);
				if($footer) $out .= '<div class="footer-author">'.$footer.'</div>';
			$out .= "</div>
		</div>";
	return $out;
}

function get_miniaction_user_rcl($action,$user_id=false){
    global $wpdb;
    if(!$action) $action = $wpdb->get_var("SELECT time_action FROM ".RCL_PREF."user_action WHERE user='$user_id'");

    $last_action = last_user_action_recall($action);

    if(!$last_action&&$action)
            $content = '<div class="status_author_mess online"></div>';
    else
            $content = '<div class="status_author_mess offline">не в сети '.$last_action.'</div>';

    return $content;
}

function rcl_action(){
    global $rcl_userlk_action;

    $last_action = last_user_action_recall($rcl_userlk_action);		
    if(!$last_action){
        echo '<div class="status_user online"></div>';
    }else{ 
        echo '<div class="status_user offline"></div>'.__('не в сети','rcl').' '.$last_action;
    }
}

function rcl_avatar($size=120){
    global $rcl_user_LK; $after='';
    echo get_avatar($rcl_user_LK,$size);
    echo apply_filters('after-avatar-rcl',$after,$rcl_user_LK);
}

function rcl_status_desc(){
    global $rcl_user_LK;
    $desc = get_the_author_meta('description',$rcl_user_LK);
    if($desc) echo '<div class="ballun-status">'
        . '<span class="ballun"></span>'
            . '<p class="status-user-rcl">'.esc_textarea($desc).'</p>'
        . '</div>';
}

function rcl_username(){
    global $rcl_user_LK;
    echo get_the_author_meta('display_name',$rcl_user_LK);
}

//Добавляем recallbar
add_action('init','add_recall_bar');
function add_recall_bar(){
	global $rcl_options;
	if($rcl_options['view_recallbar']!=1) return false;
	register_nav_menus(array( 'recallbar' => __('Recallbar','rcl') ));									
}

add_action('wp_footer','add_recallbar_menu');
function add_recallbar_menu(){
    global $rcl_options;
    if($rcl_options['view_recallbar']!=1) return false;
    include_once 'templates/recallbar.php';		
}

function recallbar_right_side(){
    $right_li='';
    echo apply_filters('recallbar_right_content',$right_li);
}

//заменяем ссылку автора комментария на ссылку его ЛК
function add_link_author_in_page($href){
	global $comment;	
	if($comment->user_id==0) return $href;
	$href = get_author_posts_url($comment->user_id);	
	return $href;
}

function rcl_add_edit_post_button($excerpt,$post=null){
if(!isset($post)) global $post;
global $user_ID;
	if($user_ID){
		if($user_ID==$post->post_author){
			$form_button = "<div class='post-edit-button'>					
				<input id='delete-post' type='image' name='delete_post' src='".RCL_URL."img/delete.png' value='".$post->ID."'></div>
				<div class='post-edit-button'>					
				<input type='image' id='edit-post' name='update_post' src='".RCL_URL."img/redactor.png' value='".$post->ID."'></div>";
		}
		
		$form_button = apply_filters('buttons_edit_post_rcl',$form_button,$post);
		
		if($form_button) $excerpt .= $form_button;
	}
	return $excerpt;
}

//запрещаем доступ в админку
add_action('init','wp_admin_success_rcl',1);
function wp_admin_success_rcl(){
	global $current_user,$rcl_options;
	if(defined( 'DOING_AJAX' ) && DOING_AJAX) return;
	if(defined( 'IFRAME_REQUEST' ) && IFRAME_REQUEST) return;
	if(is_admin()){	
		$rcl_options = unserialize(get_option('primary-rcl-options'));
		get_currentuserinfo();
		$access = 7;
		if(isset($rcl_options['consol_access_rcl'])) $access = $rcl_options['consol_access_rcl'];
		$user_info = get_userdata($current_user->ID);		
		if ( $user_info->user_level < $access ){
			if($_POST['short']==1||$_POST['fetch']==1){				
				return true;
			}else{
				if(!$current_user->ID) return true;
				wp_redirect('/'); exit;
			}
		}else {
			return true;
		}
	}	
}

function hidden_admin_panel(){
	global $current_user,$rcl_options;
	get_currentuserinfo();
	$access = 7;
	if(isset($rcl_options['consol_access_rcl'])) $access = $rcl_options['consol_access_rcl'];
	$user_info = get_userdata($current_user->ID);		
	if ( $user_info->user_level < $access ){
		show_admin_bar(false);
	}else{
		return true;
	}
}

/* Удаление поста вместе с его вложениями*/ 
function delete_attachments_with_post_rcl($postid){ 
    $attachments = get_posts( array( 'post_type' => 'attachment', 'posts_per_page' => -1, 'post_status' => null, 'post_parent' => $postid ) );    
    if($attachments){  
	foreach((array)$attachments as $attachment ){  
        wp_delete_attachment( $attachment->ID, true ); }
	}	
} 

//Функция вывода своего аватара
function custom_avatar_recall($avatar, $id_or_email, $size, $default, $alt){

	if (is_numeric($id_or_email)){
		$user_id = $id_or_email;
	}elseif( is_object($id_or_email)){
		$user_id = $id_or_email->user_id;
	}
	
	$avatar_id = get_option('avatar_user_'.$user_id);
	if ( $avatar_id ){ 
		$image_attributes = wp_get_attachment_image_src($avatar_id); 
		$avatar = "<img class='avatar' src='".$image_attributes[0]."' alt='".$alt."' height='".$size."' width='".$size."' />";
	}
	
	if ( !empty($id_or_email->user_id)) $avatar = '<a height="'.$size.'" width="'.$size.'" href="'.get_author_posts_url($id_or_email->user_id).'">'.$avatar.'</a>';
	
	return $avatar;		
}

function get_custom_post_meta_recall($post_id, $id_form=null){

	if(!$id_form) $id_form = 1;

	$get_fields = get_option( 'custom_public_fields_'.$id_form );
	$get_fields = unserialize( $get_fields);
	
	if($get_fields){
		
		foreach((array)$get_fields as $custom_field){				
			$slug = str_replace('-','_',$custom_field['slug']);
				if($custom_field['type']=='text'&&get_post_meta($post_id,$slug,1))
					$show_custom_field .= '<p><b>'.$custom_field['title'].':</b> <span>'.get_post_meta($post_id,$slug,1).'</span></p>';
				if($custom_field['type']=='select'&&get_post_meta($post_id,$slug,1)||$custom_field['type']=='radio'&&get_post_meta($post_id,$slug,1))
					$show_custom_field .= '<p><b>'.$custom_field['title'].':</b> <span>'.get_post_meta($post_id,$slug,1).'</span></p>';
				if($custom_field['type']=='checkbox'){
					$chek = explode('#',$custom_field['field_select']);
					$count_field = count($chek);					
					$n=0;
					$chek_field = '';
					for($a=0;$a<$count_field;$a++){
						$slug_chek = $slug.'_'.$a;
						if(get_post_meta($post_id,$slug_chek,1)){
						$n++;
							if($n==1) $chek_field .= get_post_meta($post_id,$slug_chek,1);
								else $chek_field .= ', '.get_post_meta($post_id,$slug_chek,1);
						}
					}
					if($n!=0) $show_custom_field .= '<p><b>'.$custom_field['title'].': </b>'.$chek_field.'</p>';
				}					
				if($custom_field['type']=='textarea'&&get_post_meta($post_id,$slug,1))
					$show_custom_field .= '<p><b>'.$custom_field['title'].':</b></p><p>'.get_post_meta($post_id,$slug,1).'</p>';
		}
		
	return $show_custom_field;
	}	
}
//add_filter('the_content','get_custom_post_meta_recall');

$gost = array(
   "Є"=>"EH","І"=>"I","і"=>"i","№"=>"#","є"=>"eh",
   "А"=>"A","Б"=>"B","В"=>"V","Г"=>"G","Д"=>"D",
   "Е"=>"E","Ё"=>"JO","Ж"=>"ZH",
   "З"=>"Z","И"=>"I","Й"=>"JJ","К"=>"K","Л"=>"L",
   "М"=>"M","Н"=>"N","О"=>"O","П"=>"P","Р"=>"R",
   "С"=>"S","Т"=>"T","У"=>"U","Ф"=>"F","Х"=>"KH",
   "Ц"=>"C","Ч"=>"CH","Ш"=>"SH","Щ"=>"SHH","Ъ"=>"'",
   "Ы"=>"Y","Ь"=>"","Э"=>"EH","Ю"=>"YU","Я"=>"YA",
   "а"=>"a","б"=>"b","в"=>"v","г"=>"g","д"=>"d",
   "е"=>"e","ё"=>"jo","ж"=>"zh",
   "з"=>"z","и"=>"i","й"=>"jj","к"=>"k","л"=>"l",
   "м"=>"m","н"=>"n","о"=>"o","п"=>"p","р"=>"r",
   "с"=>"s","т"=>"t","у"=>"u","ф"=>"f","х"=>"kh",
   "ц"=>"c","ч"=>"ch","ш"=>"sh","щ"=>"shh","ъ"=>"",
   "ы"=>"y","ь"=>"","э"=>"eh","ю"=>"yu","я"=>"ya",
   "—"=>"-","«"=>"","»"=>"","…"=>""
  );

$iso = array(
   "Є"=>"YE","І"=>"I","Ѓ"=>"G","і"=>"i","№"=>"#","є"=>"ye","ѓ"=>"g",
   "А"=>"A","Б"=>"B","В"=>"V","Г"=>"G","Д"=>"D",
   "Е"=>"E","Ё"=>"YO","Ж"=>"ZH",
   "З"=>"Z","И"=>"I","Й"=>"J","К"=>"K","Л"=>"L",
   "М"=>"M","Н"=>"N","О"=>"O","П"=>"P","Р"=>"R",
   "С"=>"S","Т"=>"T","У"=>"U","Ф"=>"F","Х"=>"X",
   "Ц"=>"C","Ч"=>"CH","Ш"=>"SH","Щ"=>"SHH","Ъ"=>"'",
   "Ы"=>"Y","Ь"=>"","Э"=>"E","Ю"=>"YU","Я"=>"YA",
   "а"=>"a","б"=>"b","в"=>"v","г"=>"g","д"=>"d",
   "е"=>"e","ё"=>"yo","ж"=>"zh",
   "з"=>"z","и"=>"i","й"=>"j","к"=>"k","л"=>"l",
   "м"=>"m","н"=>"n","о"=>"o","п"=>"p","р"=>"r",
   "с"=>"s","т"=>"t","у"=>"u","ф"=>"f","х"=>"x",
   "ц"=>"c","ч"=>"ch","ш"=>"sh","щ"=>"shh","ъ"=>"",
   "ы"=>"y","ь"=>"","э"=>"e","ю"=>"yu","я"=>"ya",
   "—"=>"-","«"=>"","»"=>"","…"=>""
  );
 
function sanitize_title_with_translit_recall($title) {
	global $gost, $iso;
	$rtl_standard = get_option('rtl_standard');
	switch ($rtl_standard) {
		case 'off':
		    return $title;		
		case 'gost':
		    return strtr($title, $gost);
		default: 
		    return strtr($title, $iso);
	}
}

if(!function_exists('sanitize_title_with_translit')) add_action('sanitize_title', 'sanitize_title_with_translit_recall', 0);

add_filter('the_content','add_message_post_moderation_rcl');
function add_message_post_moderation_rcl($cont){
global $post;
	if($post->post_status=='pending'){
		$mess = '<h3 class="pending-message">'.__('Запись ожидает утверждения!','rcl').'</h3>';
		$cont = $mess.$cont;
	}
	return $cont;
}

function add_popup_contayner_rcl(){
    $popup = '<div id="rcl-overlay"></div><div id="rcl-popup"></div>';
    echo $popup;
}
add_action('wp_footer','add_popup_contayner_rcl');

add_filter('author_link','edit_author_link_rcl',99,2);
function edit_author_link_rcl($link, $author_id){
	global $rcl_options;
	if($rcl_options['view_user_lk_rcl']!=1) return $link;
	$get = 'user';
	if($rcl_options['link_user_lk_rcl']!='') $get = $rcl_options['link_user_lk_rcl'];
	return get_redirect_url_rcl(get_permalink($rcl_options['lk_page_rcl'])).$get.'='.$author_id;	
}

function get_userfield_array_rcl($array,$field,$name_data){
	global $wpdb;
        $a=0;
	foreach((array)$array as $object){
        if(++$a>1)$userslst .= ',';
        if(is_object($array))$userslst .= $object->$name_data;
		if(is_array($array))$userslst .= $object[$name_data];
    }
	
	$users_fields = $wpdb->get_results("SELECT user_id,meta_value FROM ".$wpdb->prefix."usermeta WHERE user_id IN ($userslst) AND meta_key = '$field'");
	
	foreach((array)$users_fields as $user){
		$fields[$user->user_id] = $user->$field;
	}
	return $fields;
}

//Проверка на заполнененность обязательных полей
function get_chek_required_rcl($fields,$required){
	if(!$fields){
		foreach((array)$fields as $custom_field){				
			$slug = str_replace('-','_',$custom_field['slug']);
			$r = false;
			foreach((array)$required as $req){
				if($custom_field[$req]==1)$r = true;
			}
			if($r){
				if($custom_field['type']=='checkbox'){
					$chek = explode('#',$custom_field['field_select']);
					$count_field = count($chek);
					for($a=0;$a<$count_field;$a++){
						$slug_chek = $slug.'_'.$a;
						if($_POST[$slug_chek]=='undefined'){
							$requared = false;
						}else{
							$requared = true;
							break;
						}
					}
				}else{
					if(!$_POST[$slug]) $requared = false;	
				}
			}
		}
		if(!$requared) $requared = true;
		return $requared;
	}
}

add_filter('regform_fields_rcl','get_custom_fields_regform_rcl');
function get_custom_fields_regform_rcl($field){
	$get_fields = get_option( 'custom_profile_field' );
	$get_fields = unserialize( $get_fields);
		
	if($get_fields){
		$get_fields = stripslashes_deep($get_fields);
		$number_field=0;
			
		foreach((array)$get_fields as $custom_field){				
			if($custom_field['register']!=1) continue;
			
			$field .= '<div class="form-block-rcl">';
			$slug = str_replace('-','_',$custom_field['slug']);
			if($custom_field['requared']==1){
				$star = ' <span class="required">*</span> ';
				$req = 'required';
			}else{
				$star = '';
				$req = '';
			}
			$field .= '<label>'.$custom_field['title'].$star.':</label>';
			if($custom_field['type']=='text')
				$field .= '<input type="text" '.$req.' name="'.$slug.'" id="'.$slug.'" maxlength="50" value="" />';
			if($custom_field['type']=='textarea')
				$field .= '<textarea name="'.$slug.'" '.$req.' id="'.$slug.'" rows="5" cols="50"></textarea>';
			if($custom_field['type']=='select'){
				$fields = explode('#',$custom_field['field_select']);
				$count_field = count($fields);
				$field_select = '';
				for($a=0;$a<$count_field;$a++){
					$field_select .='<option value="'.$fields[$a].'">'.$fields[$a].'</option>';
				}
				$field .= '<select '.$req.' name="'.$slug.'" id="'.$slug.'">
				'.$field_select.'
				</select>';
			}
			$name_value[$number_field]['other'] .= $slug;
			if($custom_field['type']=='checkbox'){
				$chek = explode('#',$custom_field['field_select']);
				$count_field = count($chek);
				for($a=0;$a<$count_field;$a++){
					$number_field++;
					$slug_chek = $slug.'_'.$a;
					$field .='<input '.$req.' type="checkbox" id="'.$slug_chek.'" name="'.$slug_chek.'" value="'.esc_textarea($chek[$a]).'"> '.$chek[$a].'<br />';
					$name_value[$number_field]['chek'] .= $slug_chek;
				}
			}
			if($custom_field['type']=='radio'){
				$radio = explode('#',$custom_field['field_select']);
				$count_field = count($radio);
				$field .='<td>';
				for($a=0;$a<$count_field;$a++){
					$number_field++;
					$slug_chek = $slug.'_'.$a;
					$field .='<input '.$req.' type="radio" '.checked($a,0,false).' name="'.$slug.'" id="'.$slug_chek.'" value="'.$radio[$a].'"> '.$radio[$a].'<br />';
					$name_value[$number_field]['radio']['name'] .= $slug;
					$name_value[$number_field]['radio']['id'] .= $slug_chek;
				}
			}
			$field .= '</div>';
			$number_field++;
			
		}			
	}
	return $field;
}

add_filter('recallbar_right_content','get_default_bookmarks',10);
function get_default_bookmarks($links){
    $links .= '<li><a onclick="addfav()" href="javascript://">
                <i class="fa fa-plus"></i>В закладки</a>
            </li>
            <li><a onclick="jQuery(\'#favs\').slideToggle();return false;" href="javascript://">
                <i class="fa fa-bookmark"></i>Мои закладки</a>
            </li>';
    return $links;
}

function login_form_rcl(){
	echo get_authorize_form_rcl('floatform');
}
function get_login_form_rcl($atts){
	extract(shortcode_atts(array( 'form' => false ),$atts));
	return get_authorize_form_rcl('pageform',$form);
}
add_shortcode('loginform','get_login_form_rcl');

function get_authorize_form_rcl($type=false,$form=false){
	global $user_ID,$rcl_user_URL,$rcl_options;
	
	ob_start();	
	//include_once 'templates/regform.php';	
        echo '<div class="panel_lk_recall '.$type.'">';
		if($type=='floatform') echo '<a href="#" class="close-popup"><i class="fa fa-times-circle"></i></a>';
		if($user_ID){
		
			echo '<div class="username"><b>'.__('Привет,','rcl').' '.get_the_author_meta('display_name', $user_ID).'!</b></div>
				<div class="author-avatar">';
				echo get_avatar($user_ID, 60);
				if(function_exists('get_rayting_block_rcl')):
					//if($rcl_options['rayt_comment_user_rayt']==1||$rcl_options['rayt_post_user_rayt']==1||get_option('incentive_referal')==1):
						$karma = apply_filters('get_all_rayt_user_rcl',0,$user_ID);
						echo get_rayting_block_rcl($karma);
					//endif;
				endif;
				echo '</div>';				
					echo '<div class="buttons">
					<p><a href="'.$rcl_user_URL.'" class="recall-button"><i class="fa fa-home"></i>'.__('Личный кабинет','rcl').'</a></p>
					<p><a href="'.wp_logout_url( home_url() ).'" class="recall-button"><i class="fa fa-external-link"></i>'.__('Выход','rcl').'</a></p>
				</div>';
				
		}else{
				
			$login_form = $rcl_options['login_form_recall'];
			
			if($login_form==1&&$type!='pageform'){
				
				$redirect_url = get_redirect_url_rcl(get_permalink($rcl_options['page_login_form_recall']));
				
				echo '<div class="buttons">
				<p><a href="'.$redirect_url.'action-rcl=login" class="recall-button"><i class="fa fa-sign-in"></i>'.__('Войти','rcl').'</a></p>';
				echo '<p><a href="'.$redirect_url.'action-rcl=register" class="recall-button"><i class="fa fa-book"></i>'.__('Регистрация','rcl').'</a></p>
				</div>';
			}else if($login_form==2){											
				echo '<div class="buttons">
				<p class="parent-recbutton">'.wp_register('', '', 0).'</p>';
				echo '<p class="parent-recbutton">'.wp_loginout('/', 0).'</p>
				</div>';
			}else if($login_form==3||$type){
				
				$url = 'http://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];				
				
				if ( false !== strpos($url, '?action-rcl') ){
                                        $matches = '';
					preg_match_all('/(?<=http\:\/\/)[A-zА-я0-9\/\.\-\s\ё]*(?=\?action\-rcl)/iu',$url, $matches); 
					$host = $matches[0][0];
				}
				if ( false !== strpos($url, '&action-rcl') ){
					preg_match_all('/(?<=http\:\/\/)[A-zА-я0-9\/\.\_\-\s\ё]*(&=\&action\-rcl)/iu',$url, $matches); 
					$host = $matches[0][0];
				}
				if(!$host) $host = $_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
				
				if(!$form||$form=='sign') $f_sign = 'style="display:block;"';
				if($form=='register') $f_reg = 'style="display:block;"';
				if($form!='register'){
					echo '<div class="form-tab-rcl" id="login-form-rcl" '.$f_sign.'>
						<h4 class="form-title">Авторизация</h4>';
						if($_GET['action-rcl']=='login'){
							switch($_GET['err']){
								case 'confirm': $text = __('Ваш email не подтвержден!','rcl'); break;
								case 'empty': $text = __('Заполните поля!','rcl'); break;
								case 'failed': $text = __('Логин или пароль не верны!','rcl'); break;								
							}
                                                        $errors='';
                                                        if($text) echo '<span class="error">'.$text.'<br>' . apply_filters('login_errors', $errors) . '</span>'; 
							if(isset($_GET['success'])){
								echo '<span class="success">'.__('Регистрация завершена! Проверьте свою почту','rcl').'.</span>';
							}
						}
						echo '<form action="" method="post">							
							<div class="form-block-rcl">
								<label>'.__('Логин','rcl').' <span class="required">*</span></label>
								<input required type="text" value="" name="login-user">
							</div>
							<div class="form-block-rcl">
								<label>'.__('Пароль','rcl').' <span class="required">*</span></label>
								<input required type="password" value="" name="pass-user">';
								do_action( 'login_form' );
							echo '</div>
							<div class="form-block-rcl">
								<label><input type="checkbox" value="1" name="member-user"> '.__('Запомнить','rcl').'</label>								
							</div>
							<input type="submit" class="recall-button link-tab-form" name="submit-login" value="'.__('Отправить','rcl').'">';
							
							if(!$form) echo '<a href="#" id="link-register-rcl" class="link-tab-rcl ">'.__('Регистрация','rcl').'</a>
							<a href="#" id="link-remember-rcl" class="link-tab-rcl ">'.__('Забыли пароль?','rcl').'</a>';
							
							echo wp_nonce_field('login-key-rcl','_wpnonce',true,false).'
							<input type="hidden" name="referer_rcl" value="http://'.$host.'">
						</form>
					</div>';
				}
				if($form!='sign'){
					echo '<div class="form-tab-rcl" id="register-form-rcl" '.$f_reg.'>
						<h4 class="form-title">Регистрация</h4>';
						if($_GET['action-rcl']=='register'){
							if(isset($_GET['err'])){
								switch($_GET['err']){
									case 'login': $text = __('В логине недопустимые символы!','rcl'); break;
									case 'empty': $text = __('Заполните поля!','rcl'); break;
									case 'login-us': $text = __('Логин уже используется!','rcl'); break;
									case 'email-us': $text = __('Е-mail уже используется!','rcl'); break;
									case 'email': $text = __('Некорректный E-mail!','rcl'); break;
									default: $text = __('Ошибка заполнения!','rcl');
								}
								echo '<span class="error">'.$text.'</span>';
							}
							if(isset($_GET['success'])){
								echo '<span class="success">'.__('Регистрация завершена! Проверьте свою почту.','rcl').'</span>';
							}
						}
						//if(!$_GET['action-rcl']=='register'&&!isset($_GET['success'])){
							echo '<form action="" method="post">							
								<div class="form-block-rcl">
									<label>'.__('Логин','rcl').' <span class="required">*</span></label>
									<input required type="text" value="" name="login-user">
								</div>
								<div class="form-block-rcl">
									<label>'.__('E-mail','rcl').' <span class="required">*</span></label>
									<input required type="email" value="" name="email-user">
								</div>';
								if($rcl_options['difficulty_parole']==1){
								echo '<div class="form-block-rcl">
									<label>'.__('Пароль','rcl').' <span class="required">*</span></label>
									<input required type="password" onkeyup="passwordStrength(this.value)" value="" name="pass-user">
									<div>
										<label>Индикатор надёжности пароля:</label>
										<div id="passwordStrength" class="strength0">
											<div id="passwordDescription">Пароль не введён</div>
										</div>
									</div>
								</div>';
                                }                           }
							$fields = '';	
							echo apply_filters('regform_fields_rcl',$fields);
								
								//do_action( 'register_form' );
								echo '<input type="submit" class="recall-button" name="submit-register" value="'.__('Отправить','rcl').'">';
								
								if(!$form) echo '<a href="#" id="link-login-rcl" class="link-tab-rcl">'.__('Вход','rcl').'</a>';
								
								echo wp_nonce_field('register-key-rcl','_wpnonce',true,false).'
								<input type="hidden" name="referer_rcl" value="http://'.$host.'">
							</form>';
						//}
					echo '</div>';
				}
				if(!$form){
					echo '<div class="form-tab-rcl" id="remember-form-rcl">
						<h4 class="form-title">'.__('Генерация пароля','rcl').'</h4>';
						if($_GET['action-rcl']=='remember'){
							/*switch($_GET['err']){
								case 'email': $text = 'Некорректный E-mail!'; break;
								case 'empty': $text = 'Пустое поле!'; break;
								case 'email-nous': $text = 'Такой E-mail не зарегистрирован!'; break;								
							}
							if($text) echo '<span class="error">'.$text.'</span>';*/
							if(isset($_GET['success'])){
								echo '<span class="success">'.__('Пароль был выслан!<br>Проверьте свою почту.','rcl').'</span>';
							}
						}
						if($_GET['action-rcl']!='remember'&&!isset($_GET['success'])){
						echo '<form action="'.esc_url( site_url( 'wp-login.php?action=lostpassword', 'login_post' )).'" method="post">							
							<div class="form-block-rcl">
								<label>'.__('Имя пользователя или e-mail','rcl').'</label>
								<input required type="text" value="" name="user_login">								
							</div>
							<input type="submit" class="recall-button link-tab-form" name="remember-login" value="'.__('Отправить','rcl').'">
							<a href="#" id="link-login-rcl" class="link-tab-rcl ">'.__('Вход','rcl').'</a>
							<a href="#" id="link-register-rcl" class="link-tab-rcl ">'.__('Регистрация','rcl').'</a>
							'.wp_nonce_field('remember-key-rcl','_wpnonce',true,false).'
							<input type="hidden" name="redirect_to" value="http://'.get_redirect_url_rcl($host).'action-rcl=remember&success=true">
						</form>';
						}
					echo '</div>';
				}
			}else if(!$login_form){
				echo '<div class="buttons">
				<p><a href="#" class="recall-button sign-button"><i class="fa fa-sign-in"></i>'.__('Войти','rcl').'</a></p>';
				echo '<p><a href="#" class="recall-button reglink"><i class="fa fa-book"></i>'.__('Регистрация','rcl').'</a></p>
				</div>';
			}
				
		}
		
	echo '</div>';
	$html = ob_get_contents();
	ob_end_clean();
	
	return $html;
}

function global_recall_wpm_options(){
	$content .= ' <div id="recall" class="wrap">
	<form method="post" action="">
		'.wp_nonce_field('update-options-rmag','_wpnonce',true,false);
		
	$content = apply_filters('admin_options_rmag',$content);
	
	$content .= '<div style="width: 600px;">
	<p><input type="submit" class="button button-primary button-large right" name="primary-rmag-options" value="'.__('Сохранить настройки','rcl').'" /></p>			
	</form></div>
	</div>';
	echo $content;
}

function update_options_rmag_activate ( ) {
  if ( isset( $_POST['primary-rmag-options'] ) ) {
	if( !wp_verify_nonce( $_POST['_wpnonce'], 'update-options-rmag' ) ) return false;
    foreach($_POST as $key => $value){
		if($key=='primary-rmag-options') continue;
		$options[$key]=$value;
	}
	$options = serialize($options);
	update_option('primary-rmag-options',$options);
	wp_redirect('/wp-admin/admin.php?page=manage-wpm-options');
	exit;
  }
}
add_action('init', 'update_options_rmag_activate');

/*Внесение данных в таблицу total_rayting_posts*/
function update_total_rayting_posts_rcl(){
	global $wpdb;
	
	$total = $wpdb->get_results("SELECT post,author_post,status FROM ".RCL_PREF."rayting_post");
	$posts = array();
	foreach($total as $rayt){
		$posts[$rayt->post]['author'] = $rayt->author_post;
		$posts[$rayt->post]['rayt'] = $posts[$rayt->post]['rayt'] + $rayt->status;
	}
	
	if($posts){
		foreach((array)$posts as $p=>$data){
			$wpdb->insert(  
				RCL_PREF.'total_rayting_posts',  
				array( 'author_id' => $data['author'], 'post_id' => $p, 'total' => $data['rayt'] )
			);
		}
	}

}

/*Внесение данных в таблицу total_rayting_comments*/
function update_total_rayting_comments_rcl(){
	global $wpdb;
	
	$total = $wpdb->get_results("SELECT comment_id,author_com,rayting FROM ".RCL_PREF."rayting_comments");
	$posts = array();
	foreach($total as $rayt){
		$posts[$rayt->comment_id]['author'] = $rayt->author_com;
		$posts[$rayt->comment_id]['rayt'] = $posts[$rayt->comment_id]['rayt'] + $rayt->rayting;
	}
	if($posts){
		foreach((array)$posts as $p=>$data){
			$wpdb->insert(  
				RCL_PREF.'total_rayting_comments',  
				array( 'author_id' => $data['author'], 'comment_id' => $p, 'total' => $data['rayt'] )
			);
		}
	}
}

/*Внесение данных в таблицу total_rayting_users*/
function update_total_rayting_users_rcl(){
	global $wpdb;
	
	$all_users = $wpdb->get_results("SELECT ID FROM ".$wpdb->prefix."users");
	$users = array();
	foreach($all_users as $us){
		$users[$us->ID]['rayt'] = 0;
	}
	
	$total_com = $wpdb->get_results("SELECT comment_id,author_com,rayting FROM ".RCL_PREF."rayting_comments");
	
	foreach($total_com as $com){
		//if(!isset($users[$com->author_com])) continue;
		$users[$com->author_com]['rayt'] += $com->rayting;
	}
	
	$total_post = $wpdb->get_results("SELECT post,author_post,status FROM ".RCL_PREF."rayting_post");
	
	foreach($total_post as $post){
		//if(!isset($users[$post->author_post])) continue;
		$users[$post->author_post]['rayt'] += $post->status;
	}

	
	foreach($users as $user=>$rayt){
		$wpdb->insert(  
			RCL_PREF.'total_rayting_users',  
			array( 'user_id' => $user, 'total' => $rayt['rayt'] )
		);
	}

}

add_filter('file_scripts_rcl','get_scripts_ajaxload_tabs_rcl');
function get_scripts_ajaxload_tabs_rcl($script){
		
	$ajaxdata = "type: 'POST', data: dataString, dataType: 'json', url: '".get_bloginfo('wpurl')."/wp-admin/admin-ajax.php',";
	//$ajaxfile = "type: 'POST', data: dataString, dataType: 'json', url: '".get_bloginfo('wpurl')."/wp-content/plugins/recall/add-on/message/ajax-request.php',";	
	
	$script .= "
	function setAttr_rcl(prmName,val){
		var res = '';
		var d = location.href.split('#')[0].split('?');  
		var base = d[0];
		var query = d[1];
		if(query) {
			var params = query.split('&');  
			for(var i = 0; i < params.length; i++) {  
				var keyval = params[i].split('=');  
				if(keyval[0] != prmName) {  
					res += params[i] + '&';
				}
			}
		}
		res += prmName + '=' + val;
		return base + '?' + res;
	}

	function get_ajax_content_tab(id){			
		var lk = parseInt(jQuery('.wprecallblock').attr('id').replace(/\D+/g,''));
		var dataString = 'action=rcl_ajax_tab&id='+id+'&lk='+lk;
		jQuery.ajax({
			".$ajaxdata."
			success: function(data){
				if(data['result']==100){
					jQuery('#lk-content').html(data['content']);						
				} else {
					alert('Error');
				}
			} 
		});			
		return false;
	}
	jQuery('.ajax_button').live('click',function(){
		if(jQuery(this).hasClass('active'))return false;
		jQuery('#lk-content').html('<img class=preloader src=".RCL_URL."img/loader.gif>');
		var id = jQuery(this).attr('id');
		jQuery('#lk-menu > a').removeClass('active');		
		jQuery(this).addClass('active');
		var url = setAttr_rcl('view',id);
		if(url != window.location){
			if ( history.pushState ){
				window.history.pushState(null, null, url);
			}
		}
		get_ajax_content_tab(id);
		return false;
	});
	";
	return $script;
}
?>