<?php
/*
Plugin Name: WP-Recall
Plugin URI: http://wppost.ru
Description: Фронт-енд профиль, система личных сообщений и рейтинг пользователей на сайте вордпресс.
Version: 9.10.1
Author: Plechev Andrey
Author URI: http://vk.com/device64
*/

/*  Copyright 2012  Plechev Andrey  (email : plechev.a {at} yandex.ru)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

//определяем глобальные переменные
function get_rcl_global_unit(){
	global $wpdb;
	global $user_ID;
	global $rcl_current_action;
	global $rcl_user_URL;
	global $rcl_options;
	if(defined( 'DISALLOW_FILE_EDIT' )&&DISALLOW_FILE_EDIT==true) define( 'DISALLOW_FILE_EDIT', false );
	$rcl_options = unserialize(get_option('primary-rcl-options'));
	$upload_dir = wp_upload_dir();
	$path_parts = pathinfo(__FILE__);
	define('VER_RCL', '9.10.1');
	define('TEMP_PATH', $upload_dir['basedir'].'/temp-rcl/');
	define('TEMP_URL', $upload_dir['baseurl'].'/temp-rcl/');	
	define('RCL_PATH', $path_parts['dirname'].'/');
	define('RCL_URL', plugins_url().'/recall/');
	define('RCL_PREF', $wpdb->prefix.'rcl_');
	$rcl_user_URL = get_author_posts_url($user_ID);
	$rcl_current_action = $wpdb->get_var("SELECT time_action FROM ".RCL_PREF."user_action WHERE user='$user_ID'");	
}
add_action('init','get_rcl_global_unit',10);

require_once("functions-rcl.php");

function recall_install(){
	global $wpdb,$rcl_options;

	get_rcl_global_unit();

	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	 	
    $table4 = RCL_PREF."user_action";
    if($wpdb->get_var("show tables like '". $table4 . "'") != $table4) {
	   $wpdb->query("CREATE TABLE IF NOT EXISTS `". $table4 . "` (
		  ID bigint (20) NOT NULL AUTO_INCREMENT,
		  user INT(20) NOT NULL,	  
		  time_action DATETIME NOT NULL,
		  UNIQUE KEY id (id)
		) DEFAULT CHARSET=utf8;");
	}
	
	$upload_dir = wp_upload_dir();
	$path = $upload_dir['basedir'].'/temp-rcl/';
	if(!is_dir($path)){
		mkdir($path);
		chmod($path, 0755);
	}
	
	if(!isset($rcl_options['view_user_lk_rcl'])){
		$rcl_options['view_user_lk_rcl'] = 1;
		$rcl_options['color_theme'] = 'blue';
		$rcl_options['lk_page_rcl'] = wp_insert_post(array('post_title'=>'Личный кабинет','post_content'=>'[wp-recall]','post_status'=>'publish','post_author'=>1,'post_type'=>'page','post_name'=>'rcl-lk'));
		
		wp_insert_post(array('post_title'=>'Пользователи','post_content'=>'[userlist]','post_status'=>'publish','post_author'=>1,'post_type'=>'page','post_name'=>'users'));
		
		wp_insert_post(array('post_title'=>'FEED','post_content'=>'[feed]','post_status'=>'publish','post_author'=>1,'post_type'=>'page','post_name'=>'rcl-feed'));
		
		$active_addons = unserialize(get_option('active_addons_recall'));
		$def_addons = array('review','profile','feed','publicpost','message','rayting');
		foreach($def_addons as $addon){
			$path = RCL_PATH.'add-on/'.$addon.'/index.php';
			if ( false !== strpos($path, '\\') ) $path = str_replace('\\','/',$path);
			$active_addons[$addon]['src'] = $path;
			$install_src = RCL_PATH.'add-on/'.$addon.'/activate.php';
			$index_src = RCL_PATH.'add-on/'.$addon.'/index.php';
			if(file_exists($install_src)) include($install_src);
			if(file_exists($index_src)) include($index_src);
		}				
		update_option('active_addons_recall',serialize($active_addons));
                
                $no_action_users = $wpdb->get_results("SELECT COUNT(us.ID) FROM ".$wpdb->prefix."users AS us WHERE us.ID NOT IN (SELECT ua.user FROM ".RCL_PREF."user_action AS ua)");
	
                if($no_action_users){
                        $wpdb->query("
                                INSERT INTO ".RCL_PREF."user_action( user, time_action ) 
                                SELECT us.ID, us.user_registered
                                FROM ".$wpdb->prefix."users AS us
                                WHERE us.ID NOT IN ( SELECT user FROM ".RCL_PREF."user_action )
                        ");
                }
	}
	
	update_option('default_role','author');
	update_option('show_avatars',1);

	$roledata = array(
		'need-confirm' => array(
			'name'=>__('Неподтвержденные','rcl'),
			'cap'=>array('read' => false, 'edit_posts' => false, 'delete_posts' => false, 'upload_files' => false)
		)
	);
				
	foreach($roledata as $key=>$role){
		remove_role($key);
		add_role($key, $role['name'], $role['cap']);
	}
			
	$rcl_options['footer_url_recall']=1;
	$ser_options = serialize($rcl_options);
	update_option('primary-rcl-options',$ser_options);

    update_dinamic_files_rcl();
}
register_activation_hook(__FILE__,'recall_install');

function recall_uninstall() {
	wp_clear_scheduled_hook('days_garbage_file_rcl');
}
register_uninstall_hook(__FILE__, 'recall_uninstall');

function wp_recall($user_LK=null){

	global $wpdb,$rcl_user_LK,$rcl_userlk_action;
	
	if(!$user_LK){
		$curauth = (get_query_var('author_name')) ? get_user_by('slug', get_query_var('author_name')) : get_userdata(get_query_var('author'));
		$rcl_user_LK = $curauth->ID;
	}else{
		$rcl_user_LK = $user_LK;
	}
        
	$rcl_userlk_action = $wpdb->get_var("SELECT time_action FROM ".RCL_PREF."user_action WHERE user='$rcl_user_LK'");	

	include_once 'templates/cabinet.php';

}
function rcl_before(){
    global $rcl_user_LK; $content = '';
    echo apply_filters( 'rcl_before_lk', $content, $rcl_user_LK );
}
function rcl_after(){
    global $rcl_user_LK; $content = '';
    echo apply_filters( 'rcl_after_lk', $content, $rcl_user_LK );
}

function rcl_buttons(){
    global $rcl_user_LK; $content = '';
    echo apply_filters( 'the_button_wprecall', $content, $rcl_user_LK );	
}

function rcl_tabs(){
    global $rcl_user_LK; $content = '';
    echo apply_filters( 'the_block_wprecall', $content, $rcl_user_LK);	
}

function rcl_header(){
    global $rcl_user_LK; $content = '';
    echo apply_filters('rcl_header_user',$content,$rcl_user_LK);
}
function rcl_sidebar(){
    global $rcl_user_LK; $content = '';
    echo apply_filters('rcl_sidebar_user',$content,$rcl_user_LK);
}
function rcl_content(){
    global $rcl_user_LK; $content = '';
    echo apply_filters('rcl_content_user',$content,$rcl_user_LK);
}
function rcl_footer(){
    global $rcl_user_LK; $content = '';
    echo apply_filters('rcl_footer_user',$content,$rcl_user_LK);
}
?>